import java.io.*;
import java.util.*;
import java.util.zip.*;

public class HTCrawling {
	static Vector resultado;
	static int nchilds = 0;
	//static HTFileNode root;
      private static HTApplet   oriApplet;
	static String idBase;
	static HTCrawling htc;

	public void init(String url, String idBaseP, String deep) {		
		resultado = new Vector();
		htc=this;
		//root = nI;
		idBase=idBaseP;
		WSDLCrawler wsd = new WSDLCrawler();
		// URL, OutpuFile, MaxLevel, MaxTreads
		wsd.executar(url, "HTC.dat", deep.trim(), "3", this);		

	}

	public static void grava(String linha) {
		resultado.add(linha);
	}

      public static void setApplet(HTApplet app) {
		oriApplet = app;
     }

	public static void end() {
		String lineD;
		HTFileNode root = new HTFileNode();
		root.setHasHint(false);
		root.setEspecialMark(false);
		Date data = new Date();
		root.setID("_"+data.getTime()+"_F");

		HTFileNode noCorrente = root;
		String dd;
		String NP = "";
		String hint;
		boolean first=true;
		for(int j=0; j < resultado.size(); j++) {
			lineD = (String) resultado.elementAt(j);
			StringTokenizer stDatas = new StringTokenizer(lineD, ",");
			noCorrente = root;

			int i =0;
			String id = idBase;

			int nc = stDatas.countTokens();
			String url = "";

			while (stDatas.hasMoreTokens()) {

			String tokenD;
			
			if (stDatas.hasMoreTokens()) {
				i++;
				NP = stDatas.nextToken();

				if (NP.toLowerCase().indexOf("http://")>=0) {
					url = NP;
					int li = NP.lastIndexOf("/");
					if ((li >= 0) && (li < NP.length()-1)) {
						NP = NP.substring(li+1);
					}
					else {
						if (li >= 0) {
							NP = NP.substring(0,li);
							li = NP.lastIndexOf("/");
							if (li >= 0) NP = NP.substring(li+1); 
						}
					}
				}
				id = id + "." + NP;
				
				if (first) {
					addAtributos(root, NP, NP, url, id);
					noCorrente = root;
					first=false;
				}

				HTFileNode no = findNo(root, id);
				hint = "";
				
				if (no == null) {
					noCorrente = insereFilho(noCorrente, NP, NP, url, id);
					root.setLeafNode(false);

				} else {
					noCorrente = no;
				}
			}
			}

		}
		oriApplet.setNewNodes(root);
	}

	public static void processou(String msg) {
		oriApplet.crowlingFeedBack();
		//System.err.print("-");
	}

	public Vector getResultado() {
		return(resultado);
	}


	/**
	 *  Adds a feature to the Atributos attribute of the ConverteCSV2HTZ_SEG class
	 *
	 * @param  node   The feature to be added to the Atributos attribute
	 * @param  texto  The feature to be added to the Atributos attribute
	 * @param  hint   The feature to be added to the Atributos attribute
	 */
	public static void addAtributos(HTFileNode node, String texto, String hint, String url, String id) {

		String textColorDefault = "0x000000";
		String nodeColorDefault = "0xA0B200";
		node.setID(id);
		nchilds++;
		node.setColor(nodeColorDefault);
		node.setTextColor(textColorDefault);
		node.setName(texto);
		node.setHint(hint);
		node.setURL(url);
		node.setHasHint(false);
		node.setEspecialMark(false);
		node.setLeafNode(true);

	}

	/**
	 *  Description of the Method
	 *
	 * @param  pai    Description of the Parameter
	 * @param  texto  Description of the Parameter
	 * @param  hint   Description of the Parameter
	 * @return        Description of the Return Value
	 */
	public static HTFileNode insereFilho(HTFileNode pai, String texto, String hint, String url, String id) {

		String textColorDefault = "0x000000";
		String nodeColorDefault = "0xA0B200";

		HTFileNode node = new HTFileNode();
		Date data = new Date();
		node.setID("_"+data.getTime()+"_F");


		addAtributos(node, texto, hint, url, id);

		pai.setLeafNode(false);
		pai.setHasHint(false);
		pai.setEspecialMark(false);
		pai.addChild(node);

		return (node);
	}


	/**
	 *  Description of the Method
	 *
	 * @param  no  Description of the Parameter
	 * @param  id  Description of the Parameter
	 * @return     Description of the Return Value
	 */
	public static HTFileNode findNo(HTFileNode no, String id) {
		if (no.getID().trim().equals(id.trim())) {
			return (no);
		}

		return buscaNo(no, id);
	}

	/**
	 *  Description of the Method
	 *
	 * @param  node  Description of the Parameter
	 * @param  id    Description of the Parameter
	 * @return       Description of the Return Value
	 */
	public static HTFileNode buscaNo(HTFileNode node, String id) {
		for (Enumeration e = node.children(); e.hasMoreElements(); ) {
			HTFileNode childNode = (HTFileNode) e.nextElement();
			if (childNode.getID().trim().equals(id.trim())) {
				return (childNode);
			}

			if (!childNode.isLeaf()) {
				HTFileNode ret = buscaNo(childNode, id);
				if (ret != null) {
					return (ret);
				}
			}
		}
		return (null);
	}

}