import java.util.*;
import java.awt.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.awt.event.*;

public class SelectableTree extends JFrame implements ActionListener, TreeSelectionListener {
  private JTree tree;
  private JTextField currentSelectionField;
  Container content;
  DefaultMutableTreeNode root;
  static HTFileNode HT = null;

   final static Color bg = Color.white;
    final static Color fg = Color.black;
    final static Color red = Color.red; 
    final static Color white = Color.white;

    final static BasicStroke stroke = new BasicStroke(2.0f);
    final static BasicStroke wideStroke = new BasicStroke(8.0f);
    
    final static float dash1[] = {10.0f};
    final static BasicStroke dashed = new BasicStroke(1.0f,
                                                      BasicStroke.CAP_BUTT,
                                                      BasicStroke.JOIN_MITER,
                                                      10.0f, dash1, 0.0f);
    final static JButton buttonIA = new JButton("imprimir tudo");
    final static JButton buttonIT = new JButton("imprimir tela");

   public void actionPerformed(ActionEvent e) {
        if (e.getSource() == buttonIA) { //instanceof JButton) { 
		PrintUtilities.printComponent(tree);
 	  }
        if (e.getSource() == buttonIT) { //instanceof JButton) { 
		PrintUtilities.printComponent(this);
 	  }
    }

  public SelectableTree(HTFileNode r) {
	super("Contedo da rvore");
	HT = r;
	setBackground(bg);
      buttonIA.addActionListener(this);
	buttonIT.addActionListener(this);

      //WindowUtilities.setNativeLookAndFeel();
      addWindowListener(new ExitListener());
      content = getContentPane();
      root =new DefaultMutableTreeNode(r.getName());
	buildTree(r, root);
      tree = new JTree(root);
	tree.setEditable(true) ;
	try {
		for (int i=0; i < 1000; i++) {
			tree.expandRow(i);
			//childFolder.TOOL_TIP_TEXT_KEY = childNode.getHint();
		}
      }
      catch (Exception pe) {
      }

      tree.addTreeSelectionListener(this);
      content.add(new JScrollPane(tree), BorderLayout.CENTER);
	JPanel panel = new JPanel();
	panel.add(buttonIA);
	panel.add(buttonIT);
	content.add(panel, BorderLayout.SOUTH);
      setSize(600, 800);
      setVisible(true);
  }

   public void buildTree(HTFileNode node, DefaultMutableTreeNode root) {

		for (Enumeration e = node.children(); e.hasMoreElements(); ) {
			DefaultMutableTreeNode childFolder;
            	HTFileNode childNode = (HTFileNode) e.nextElement();
			childFolder = new DefaultMutableTreeNode(childNode.getName());
			
		      root.add(childFolder);
						
            	if (!childNode.isLeaf()) {
				buildTree(childNode, childFolder);
            	}
		}
    }


  public void valueChanged(TreeSelectionEvent event) {
    //currentSelectionField.setText("Current Selection: " + tree.getLastSelectedPathComponent().toString());
  }

}