//package ie.moguntia.webcrawler;
//import ie.moguntia.threads.*;
import java.net.*;

public class WSDLCrawler implements MessageReceiver {
	static HTCrawling craw;

	public WSDLCrawler() {

	}
	public WSDLCrawler(Queue q, int maxLevel, int maxThreads)
		throws InstantiationException, IllegalAccessException {
		ThreadController tc = new ThreadController(WSDLCrawlerThread.class,
												   maxThreads,
												   maxLevel,
												   q,
												   0,
												   this);
	}

	public void finishedAll() {
		// ignore
		craw.end();
	}

	public void receiveMessage(Object o, int threadId) {
		// In our case, the object is already string, but that doesn't matter
		//System.out.println("[" + threadId + "] " + o.toString());
	}

	public void finished(int threadId) {
		
				//System.out.println("[" + threadId + "] finished");

	}

	public void executar(String args0, String args1, String args2, String args3, HTCrawling htc) {
		try {
			craw = htc;
			int maxLevel = 2;
			int maxThreads = 5;
			maxThreads = Integer.parseInt(args3);
			maxLevel = Integer.parseInt(args2);
			URLQueue q = new URLQueue();
			q.setFilenamePrefix(args1);
			System.out.println("[-1] "+ args0);
			q.push(new URL(args0), 0);
			new WSDLCrawler(q, maxLevel, maxThreads);
			return;
		} catch (Exception e) {
			System.err.println("An error occured: ");
			e.printStackTrace();
			// System.err.println(e.toString());
		}
		System.err.println("Usage: java WSDLCrawler <url> <filenamePrefix> [<maxLevel> [<maxThreads>]]");
		System.err.println("Crawls the web for WSDL descriptions.");
	}
}
