import java.io.*;
import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.nio.channels.FileChannel;
import java.util.zip.*;
import java.util.*;
import java.util.zip.*;

 
public class treeFromFolder {
 
	/**
	 * @param args
	 * @throws IOException 
	 * Count files in <path> and all its subDirs
	 */
	
	public static String path = "c:/users/hypertree";
	public static String src1 = "";
	public static FileChannel channel;
	public static int numF;
	public static int numD;
      static int nchilds = 0;

	public static void countFiles(String strPath, HTFileNode root) throws IOException
	{
		File src = new File(strPath);
				
		if (src.isDirectory())
		{
			numD++;

			String list[] = src.list();

			try {
			    for (int i = 0; i < list.length; i++)
			    {
				src1 = src.getAbsolutePath() + "/" + list[i];
				File file = new File(src1);
				HTFileNode root1 = insereFilho(root, file.getName(), file.getName(), "", numF+"."+numD);//hint, url1, id);
				try {
		        	    channel = new RandomAccessFile(file, "r").getChannel();
				}catch(java.io.FileNotFoundException e){}
 
				countFiles(src1, root1);
				channel.close();
			    }
			}catch(java.lang.NullPointerException e){}
		}
		else { 
		    HTFileNode node=insereFilho(root, src.getName(), "", src.getAbsolutePath(), numF+".");//hint, url1, id);
		    numF++;
		}
	}
	/**
	 *  Adds a feature to the Atributos attribute of the ConverteCSV2HTZ_SEG class
	 *
	 * @param  node   The feature to be added to the Atributos attribute
	 * @param  texto  The feature to be added to the Atributos attribute
	 * @param  hint   The feature to be added to the Atributos attribute
	 */
	public static void addAtributos(HTFileNode node, String texto, String hint, String url, String id) {

		String textColorDefault = "0x000000";
		String nodeColorDefault = "0xA0B200";

		Date data = new Date();
		node.setID("_"+data.getTime()+"_F");

		nchilds++;

		node.setColor(nodeColorDefault);
		node.setTextColor(textColorDefault);
		node.setName(texto);
		node.setHint(hint);
		node.setURL(url);
		node.setHasHint(false);
		node.setEspecialMark(false);

		node.setLeafNode(true);

	}


	/**
	 *  Description of the Method
	 *
	 * @param  pai    Description of the Parameter
	 * @param  texto  Description of the Parameter
	 * @param  hint   Description of the Parameter
	 * @return        Description of the Return Value
	 */
	public static HTFileNode insereFilho(HTFileNode pai, String texto, String hint, String url, String id) {

		String textColorDefault = "0x000000";
		String nodeColorDefault = "0xA0B200";

		HTFileNode node = new HTFileNode();
		Date data = new Date();
		node.setID("_"+data.getTime()+"_F");

		addAtributos(node, texto, hint, url, id);

		pai.setLeafNode(false);
		pai.setHasHint(false);
		pai.setEspecialMark(false);
		pai.addChild(node);

		return (node);
	}


	/**
	 *  Description of the Method
	 *
	 * @param  root  Description of the Parameter
	 */
	public static void grava(HTFileNode root) {
		try {
			GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream("seg1.htz"));
			ObjectOutputStream po = new ObjectOutputStream(zip);
			po.writeObject(root);
			zip.close();

		} catch (Exception e) {
			System.out.println("\nGrava de Objetos  :" +
					e.toString());
		}
		System.out.println("Hipertree Gravada.");
	}

}