//import hypertree.HyperTree;
//import hypertree.HTView;
import java.io.*;
import java.util.*;
import java.util.zip.*;
import java.applet.*;
import java.awt.*;
import java.net.URL;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * @author     silvio
 * @created    18 de Abril de 2005
 */

public class HTApplet extends Applet implements ActionListener {
	private static HTFileNode root = null;
	//private static HTFileNodeV16 rootV16 = null;
	// the root of the demo tree
	private static HyperTree hypertree = null;
	// the hypertree builded
	private static HTView view;
	// Bruno
	/**
	 *  Description of the Field
	 */
	public HTDialogShapes dlgFormas;
	//TextField nomeField;
	TextField corField;
	TextField corText;
	TextField hintField;
	TextField urlField;
	TextField textField;
	TextField arestaField;
	int ntNos = 0;
	Panel panel;
	Label arestaLabel;
	Label corLabel;
	Label corTextLabel;
	Label hintLabel;
	Label urlLabel;
	Label textLabel;
	private int undoControlAtual = 0;
	private int undoControlBase = 0;
	private Image imageH;
	private Image imageO;
	private Image imageC;
	private Image imageA;
	private Image imageB;
	private Image imageS;
	static JFrame viewFrame, viewFrameOld;

	String htFile;
	String htHintColor;
	String htCenterNode;
	String htBackColor;
	String htGraphColor;
	String htBackColorEdit;
	String htSearchType;
	// 14/11/2005
	String htLinkColor;
	String htSearchColor;
	String htBorderType;
	String htFont;
	String htFontSize;
	String htHomeImage;
	String htConfirmarImage;
	String htCancelarImage;
	String htAplicarImage;
	String curDir = "";
	String htHelpImage;
	String htBackImage;
	String htHelpFile;
	String htUrlAdr;
	String htLiteAdr;
	String pathRoot = null;
	JMenuBar menubar;
	private HTVector graph = null;

	boolean lineGraph = true;


	/**
	 *Constructor for the HTApplet object
	 */

	public HTApplet() { }


	/**
	 *  Description of the Method
	 *
	 * @param  name     Description of the Parameter
	 * @param  gridbag  Description of the Parameter
	 * @param  c        Description of the Parameter
	 * @param  panel    Description of the Parameter
	 * @param  hint     Description of the Parameter
	 * @return          Description of the Return Value
	 */

	protected Button makebutton(String name, GridBagLayout gridbag,
			GridBagConstraints c, Panel panel, String hint) {
		Button button = new Button(name);
		gridbag.setConstraints(button, c);
		//button.setToolTipText(hint);
		panel.add(button);
		return button;
	}

	/**
	 *  Description of the Method
	 *
	 * @param  name     Description of the Parameter
	 * @param  gridbag  Description of the Parameter
	 * @param  c        Description of the Parameter
	 * @param  d        Description of the Parameter
	 */

	protected void makeLabel(String name, GridBagLayout gridbag,
			GridBagConstraints c, double d) {
		c.weightx = 0.5;
		textLabel = new Label(name);
		textLabel.setForeground(Color.black);
		textLabel.setBackground(Color.lightGray);
		gridbag.setConstraints(textLabel, c);
		add(textLabel);
		c.weightx = d;
		textField = new TextField(16);
		textField.setBackground(Color.lightGray);
		gridbag.setConstraints(textField, c);
		add(textField);
	}


	/**
	 *  Description of the Method
	 *
	 * @param  jframe  Description of the Parameter
	 */

	protected void makeMenuBar(JFrame jframe) {

		menubar = new JMenuBar();

		menubar.setBorder(new BevelBorder(BevelBorder.RAISED));

		HTToolBar toolbar = new HTToolBar(view);

		toolbar.addSeparator();

		toolbar.addSeparator();

		toolbar.addSeparator();

		//toolbar.addSeparator();

		//toolbar.addSeparator();

		//toolbar.addSeparator();

		//toolbar.addSeparator();

		//toolbar.addSeparator();

		//toolbar.addSeparator();

		//toolbar.addSeparator();

		//toolbar.addSeparator();

		Label search = new Label("Busca:", 2);

		toolbar.add(search);

		TextField searchField = new TextField(8);

		view.setSearchField(searchField);

		searchField.addTextListener(new HTListenerText(view));

		toolbar.add(searchField);

		Insets margins = new Insets(2, 15, 20, 15);

		toolbar.setMargin(margins);

		menubar.add(toolbar);

	}


	/**
	 *  Description of the Method
	 *
	 * @param  name     Description of the Parameter
	 * @param  gridbag  Description of the Parameter
	 * @param  c        Description of the Parameter
	 * @param  d        Description of the Parameter
	 */

	protected void makeLabelR(String name, GridBagLayout gridbag,
			GridBagConstraints c, double d) {

		c.weightx = 0.5;

		textLabel = new Label(name);

		textLabel.setForeground(Color.black);

		textLabel.setBackground(Color.lightGray);

		view.setTextLabel(textLabel);

		gridbag.setConstraints(textLabel, c);

		add(textLabel);

		c.weightx = d;

		c.gridwidth = GridBagConstraints.REMAINDER;

		//end row

		textField = new TextField(16);

		textField.setBackground(Color.lightGray);

		gridbag.setConstraints(textField, c);

		add(textField);

	}


	/**
	 *  Description of the Method
	 *
	 * @param  viewFrame  Description of the Parameter
	 */

	protected void makeInterfaceEditor(JFrame viewFrame) {

		GridBagLayout gridbag = new GridBagLayout();

		GridBagConstraints c = new GridBagConstraints();

		Panel panel = new Panel();

		panel.setSize(new Dimension(viewFrame.getWidth(), 140));

		panel.setLayout(gridbag);

		htBackColorEdit = "0x9999BB";

		panel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));

		view.setPanel(panel);

		panel.setVisible(false);

		viewFrame.getContentPane().add(panel);

		c.weightx = 0;

		c.insets = new Insets(4, 0, 4, 0);

		c.anchor = GridBagConstraints.EAST;

		textLabel = new Label("Nome:", 2);

		textLabel.setFont(new Font("SansSerif", Font.BOLD, 11));

		textLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));

		if (htBackColorEdit.trim().equals("0x000000")) {

			textLabel.setForeground(Color.white);

		} else {

			textLabel.setForeground(Color.black);

		}

		view.setTextLabel(textLabel);
		gridbag.setConstraints(textLabel, c);
		panel.add(textLabel);
		textField = new TextField(16);
		textField.setFont(new Font("SansSerif", Font.PLAIN, 11));
		textField.setBackground(Color.lightGray);
		view.setTextField(textField);
		gridbag.setConstraints(textField, c);
		panel.add(textField);

		c.anchor = GridBagConstraints.EAST;

		// Aresta: 18/04/2005

		arestaLabel = new Label(" Aresta:", 2);
		arestaLabel.setFont(new Font("SansSerif", Font.BOLD, 11));
		arestaLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));

		if (htBackColorEdit.trim().equals("0x000000")) {
			arestaLabel.setForeground(Color.white);
		} else {
			arestaLabel.setForeground(Color.black);
		}
		view.setArestaLabel(arestaLabel);
		gridbag.setConstraints(arestaLabel, c);
		panel.add(arestaLabel);
		c.anchor = GridBagConstraints.CENTER;
		arestaField = new TextField(10);
		arestaField.setFont(new Font("SansSerif", Font.PLAIN, 11));
		arestaField.setBackground(Color.lightGray);
		view.setArestaField(arestaField);
		gridbag.setConstraints(arestaField, c);
		panel.add(arestaField);
		arestaField.setEnabled(true);
		// Aresta: 18/04/2005
		corLabel = new Label("  Cor:", 2);
		corLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
		corLabel.setFont(new Font("SansSerif", Font.BOLD, 11));
		if (htBackColorEdit.trim().equals("0x000000")) {
			corLabel.setForeground(Color.white);
		} else {
			corLabel.setForeground(Color.black);
		}
		view.setCorLabel(corLabel);
		gridbag.setConstraints(corLabel, c);
		panel.add(corLabel);
		c.anchor = GridBagConstraints.CENTER;
		corField = new TextField(6);
		corField.setFont(new Font("SansSerif", Font.PLAIN, 11));
		corField.setBackground(Color.lightGray);
		view.setCorField(corField);
		gridbag.setConstraints(corField, c);
		panel.add(corField);
		corField.setEnabled(true);
		view.setCorF(makebutton("...", gridbag, c, panel,
				"Definir a cor do n."));
		view.setAplicarF(makebutton("Ramo", gridbag, c, panel,
				"Aplicar a cor escolhida a todos os filhos do n selecionado."));
		corTextLabel = new Label("  Cor Texto:", 2);
		corTextLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
		corTextLabel.setFont(new Font("SansSerif", Font.BOLD, 11));

		if (htBackColorEdit.trim().equals("0x000000")) {
			corTextLabel.setForeground(Color.white);
		} else {
			corTextLabel.setForeground(Color.black);
		}

		view.setCorTextLabel(corTextLabel);

		gridbag.setConstraints(corTextLabel, c);

		panel.add(corTextLabel);

		c.anchor = GridBagConstraints.CENTER;

		corText = new TextField(6);

		corText.setFont(new Font("SansSerif", Font.PLAIN, 11));

		corText.setBackground(Color.lightGray);

		view.setCorText(corText);

		gridbag.setConstraints(corText, c);

		panel.add(corText);

		corText.setEnabled(true);

		view.setCorT(makebutton("...", gridbag, c, panel,
				"Definir a cor do texto."));

		view.setAplicarT(makebutton("Ramo", gridbag, c, panel,
				"Aplicar a cor escolhida a todos os filhos do n selecionado."));

		Label dummy0 = new Label(" ");

		dummy0.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));

		view.setCorTextLabel(dummy0);

		gridbag.setConstraints(dummy0, c);

		panel.add(dummy0);

		view.setAplicarI(makebutton("Imagem... ", gridbag, c, panel,
				"Definir uma imagem para o n."));

		view.setAplicarRI(makebutton("Remover Imagem", gridbag, c,
				panel, "Apagar Imagem associada ao n"));

		c.gridwidth = GridBagConstraints.REMAINDER;

		//end row

		Label dummy = new Label(" ");

		dummy.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));

		view.setCorTextLabel(dummy);

		gridbag.setConstraints(dummy, c);

		panel.add(dummy);

		c.gridwidth = 1;

		// GridBagConstraints.RELATIVE; //next-to-last in row

		hintLabel = new Label(" Hint: ");

		hintLabel.setFont(new Font("SansSerif", Font.BOLD, 11));

		hintLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));

		if (htBackColorEdit.trim().equals("0x000000")) {

			hintLabel.setForeground(Color.white);

		} else {

			hintLabel.setForeground(Color.black);

		}

		view.setHintLabel(hintLabel);

		gridbag.setConstraints(hintLabel, c);

		panel.add(hintLabel);

		c.gridwidth = GridBagConstraints.REMAINDER;

		//end row

		hintField = new TextField(90);

		hintField.setFont(new Font("SansSerif", Font.PLAIN, 11));

		hintField.setBackground(Color.lightGray);

		view.setHintField(hintField);

		// **

		gridbag.setConstraints(hintField, c);

		panel.add(hintField);

		c.gridwidth = 1;

		view.setLinks(makebutton(" Links ", gridbag, c, panel,
				"Links"));

		//view.setLinks(makebutton(" Tipo de No ", gridbag, c, panel, "Links"));

		c.gridwidth = 1;

		c.gridwidth = 1;

		view.setFormas(makebutton(" Formas ", gridbag, c, panel,
				"Formas"));

		c.gridwidth = 1;

		// GridBagConstraints.SOUTHWEST;//RELATIVE; //next-to-last in row

		/*
		 *  Bruno - 08/08/08
		 *  Trecho de codigo substituido pelo form de URLs
		 *
		 *  urlLabel = new Label(" URL: ");
		 *  urlLabel.setFont(new Font("SansSerif", Font.BOLD, 11));
		 *  urlLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
		 *  if (htBackColorEdit.trim().equals("0x000000")) {
		 *  urlLabel.setForeground(Color.white);
		 *  } else {
		 *  urlLabel.setForeground(Color.black);
		 *  }
		 *  view.setURLLabel(urlLabel);
		 *  gridbag.setConstraints(urlLabel, c);
		 *  panel.add(urlLabel);
		 *  c.gridwidth = GridBagConstraints.REMAINDER;
		 *  /end row
		 *  urlField = new TextField(90);
		 *  urlField.setFont(new Font("SansSerif", Font.PLAIN, 11));
		 *  urlField.setBackground(Color.lightGray);
		 *  view.setURLField(urlField);
		 *  gridbag.setConstraints(urlField, c);
		 *  panel.add(urlField);
		 */
		// Precisa criar, se nao nao aparece as opcoes de editar

		view.setURLField(new TextField(""));

		// Fim Bruno

		c.anchor = GridBagConstraints.CENTER;

		c.ipady = 12;

		c.ipadx = 12;

		c.gridwidth = 4;

		//GridBagConstraints.RELATIVE; //next-to-last in row

		view.setOk(makebutton("   OK   ", gridbag, c, panel,
				"Aplicar alteraes ao n selecioando"));

		view.setCancel(makebutton("Cancelar", gridbag, c, panel,
				"No Aplicar alteraes ao n selecioando"));

	}


	/**
	 *  Gets the graph attribute of the HTApplet object
	 *
	 * @return    The graph value
	 */
	HTVector getGraph() {

		return graph;
	}


	/**
	 *  Description of the Method
	 */

	public void init() {

		pathRoot = null;

		htFile = getParameter("htfile");

		htHintColor = getParameter("hthintcolor");

		htCenterNode = getParameter("htcenternode");

		htBackColor = getParameter("htbackcolor");

		htBackColorEdit = getParameter("htbackcoloredit");

		htLinkColor = getParameter("htlinkcolor");

		htGraphColor = getParameter("htgraphcolor");

		htSearchColor = getParameter("htsearchcolor");

		htBorderType = getParameter("htbordertype");

		htFont = getParameter("htfont");

		htFontSize = getParameter("htfontsize");

		htHomeImage = getParameter("hthomeimage");

		htConfirmarImage = getParameter("htconfirmarimage");

		htCancelarImage = getParameter("htcancelarimage");

		htAplicarImage = getParameter("htaplicarimage");

		htHelpImage = getParameter("hthelpimage");

		htBackImage = getParameter("htbackimage");

		htHelpFile = getParameter("hthelpfile");

		htUrlAdr = getParameter("hturladr");

		htSearchType = getParameter("htsearchtype");

		String htOpenWindow = getParameter("htopenwindow");
		
		htLiteAdr = getParameter("htLiteAdr");

		// 14/11/2005
		if (htFile == null) {
			System.out.println("Arquivo com a rvore Hiperblica no foi especificado");
			return;
		}

		try {
			URL url = new URL(getCodeBase(), "");
			curDir = url.getPath();
			System.out.println(curDir);
			if ((curDir.charAt(0) == '/') && curDir.toLowerCase().indexOf("c:") >= 0) {
				curDir = curDir.substring(1);
			}
			curDir = curDir.trim();
			curDir = curDir.replaceAll("%20", " ");
			System.out.println(System.getProperty("java.vm.version"));

			// Criando, se necessrio, diretrio para operao de UNDO
			boolean success = (new File("undo")).mkdir();
		} catch (Exception e) {
			System.out.println(e.toString());
		}

		try {
			System.out.println("Abrindo verso 3.0 do arquivo HTZ");
			GZIPInputStream zip = new GZIPInputStream((new URL(getCodeBase(), htFile)).openStream());
			ObjectInputStream pi = new ObjectInputStream(zip);
			root = (HTFileNode) pi.readObject();
			convertPixes2Image(root, true);
			verificaNImporte(root);
			zip.close();

		} catch (Exception e) {

			System.out.println("Criando HTZ novo");
			root = new HTFileNode();
			HTFileNode filho = new HTFileNode();
			String id = "_1";
			Date data = new Date();
			id = "_" + data.getTime() + "_Root";

			root.setID(id);
			root.setColor("0xFF0000");
			//nodeColorDefault);
			root.setTextColor("0xFFFF00");
			root.setName("Raiz ");
			root.setLeafNode(false);

			filho.setID("_" + data.getTime() + "_F");
			filho.setColor("0x00FF00");
			//nodeColorDefault);
			filho.setTextColor("0xFF0000");
			filho.setName("Filho 1 ");
			filho.setLeafNode(true);
			root.addChild(filho);
		}

		try {
			GZIPInputStream zip = new GZIPInputStream((new URL(getCodeBase(), htFile.toLowerCase().replaceAll(".htz", ".vec")).openStream()));
			ObjectInputStream pi = new ObjectInputStream(zip);
			HTVector graphOld = (HTVector) pi.readObject();
			graph = new HTVector();
			for (int i = 0; i < graphOld.size(); i++) {
				HTPointGraph htp = (HTPointGraph) graphOld.elementAt(i);
				HTFileNode no1 = findNo(root,
						htp.getNode1().getID());
				HTFileNode no2 = findNo(root,
						htp.getNode2().getID());
				HTPointGraph v = new HTPointGraph(no1, no2);
				v.setDirecionado(htp.getDirecionado());
				v.setArcName(htp.getArcName());
				graph.add((Object) v);
			}
			zip.close();
		} catch (Exception e) {
			graph = new HTVector();
			System.out.println(e.toString());
		}

		if (root == null) {
			System.err.println("Erro : No foi possvel iniciar a rvore Hiperblica");
			return;
		} else {
			try {
				GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream(curDir + "undo/" + htFile + ".bac"));
				ObjectOutputStream po = new ObjectOutputStream(zip);
				po.writeObject(root);
				zip.close();
			} catch (Exception e) {
				System.out.println("\nGrava de Objetos  :" + e.toString());
			}
		}

		hypertree = new HyperTree(root, this);
		view = hypertree.getView();
		view.setApplet(this);
		view.setPath(curDir);
		// Inicializa as formas
		Frame f = new Frame("Formas");
		dlgFormas = new HTDialogShapes(f, view.getPath());
		view.criaDlgFormas(dlgFormas);

		if (htHintColor != null) {
			view.setHintColor(htHintColor);
		}
		if (htBackColor != null) {
			view.setBackColor(htBackColor);
		}

		if (htGraphColor != null) {

			view.setGraphColor(htGraphColor);

		}

		if (htBackColorEdit != null) {

			view.setBackColorEdit(htBackColorEdit);

		} else {

			htBackColorEdit = "0x9999BB";

			view.setBackColorEdit(htBackColorEdit);

		}

		if (htLinkColor != null) {

			view.setLinkColor(htLinkColor);

		}

		if (htSearchColor != null) {

			view.setSearchColor(htSearchColor);

		}

		if (htOpenWindow != null) {

			view.setOpenWindow(htOpenWindow.toLowerCase());

		}

		if (htBorderType != null) {

			view.setBorderType(htBorderType);

		}

		if (htCenterNode != null) {

			view.setCenterNode(htCenterNode);

		}

		if (htHelpFile != null) {

			view.setHelpFile(htHelpFile);

		}

		if (htUrlAdr != null) {

			view.setUrlAdr(htUrlAdr);

		}
		
		if (htLiteAdr != null) {

			view.setLiteAdr(htLiteAdr);

		}
		

		// 14/11/2005

		if (htSearchType != null) {

			view.setSearchType(htSearchType.trim().toLowerCase());

		} else {

			view.setSearchType("line");

		}

		// *****

		if (htFont != null) {

			view.setFontNode(htFont);

		} else {

			view.setFontNode("Serif");

		}

		if (htFontSize != null) {

			view.setFontSizeNode(((new Integer(htFontSize)).intValue()));

		} else {

			view.setFontSizeNode(12);

		}

		if (htHomeImage != null) {

			imageH = getImage(getCodeBase(), htHomeImage);

			if (imageH != null) {

				view.setHomeImage(imageH);

			}
		} else {

		}

		if (htConfirmarImage != null) {

			imageO = getImage(getCodeBase(), htConfirmarImage);

			if (imageO != null) {

				view.setConfirmarImage(imageO);

			}
		} else {

		}

		if (htCancelarImage != null) {

			imageC = getImage(getCodeBase(), htCancelarImage);

			if (imageC != null) {

				view.setCancelarImage(imageC);

			}
		} else {

		}

		if (htAplicarImage != null) {

			imageA = getImage(getCodeBase(), htAplicarImage);

			if (imageA != null) {

				view.setAplicarImage(imageA);

			}
		} else {

		}

		if (htBackImage != null) {

			imageB = getImage(getCodeBase(), htBackImage);

			if (imageB != null) {

				view.setBackImage(imageB);

			}
		} else {

		}

		if (htHelpImage != null) {

			imageS = getImage(getCodeBase(), htHelpImage);

			if (imageS != null) {

				view.setHelpImage(imageS);

			}
		} else {

		}

		// AWT - PAnel

		setLayout(new BorderLayout());

		setBackground(Color.lightGray);

		//new Color (Color.decode(view.getBackColor()).getRGB()));

		int h = getHeight();

		int w = getWidth();

		setSize(new Dimension(w, h));

		setVisible(false);

		// Era True

		viewFrame = new JFrame(root.getName());

		viewFrame.setContentPane(view);

		viewFrame.setSize(w, h);

		viewFrame.setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));

		makeInterfaceEditor(viewFrame);

		view.setViewFrame(viewFrame);

		makeMenuBar(viewFrame);

		viewFrame.setJMenuBar(menubar);

		viewFrame.setVisible(true);

	}


	/**
	 *  Sets the visibles attribute of the HTApplet object
	 */

	public final void setVisibles() {

		viewFrame.setJMenuBar(menubar);

		viewFrame.setVisible(true);

	}


	/**
	 *  Description of the Method
	 *
	 * @param  center  Description of the Parameter
	 */

	public final void reLoad(String center) {

		//this.destroy();

		//hypertree   = new HyperTree(root, this);

		hypertree.setNewHyperTree(root, this);

		//view.destroy();

		boolean isEdited = view.getIsEdited();

		view = null;

		System.gc();

		view = hypertree.getView();

		view.setApplet(this);

		// Bruno

		view.criaDlgFormas(dlgFormas);

		if (htHintColor != null) {

			view.setHintColor(htHintColor);

		}

		if (htBackColor != null) {

			view.setBackColor(htBackColor);

		}

		if (htGraphColor != null) {

			view.setGraphColor(htGraphColor);

		}

		if (htLinkColor != null) {

			view.setLinkColor(htLinkColor);

		}

		if (htSearchColor != null) {

			view.setSearchColor(htSearchColor);

		}

		if (htBorderType != null) {

			view.setBorderType(htBorderType);

		}

		if (center != null) {

			view.setCenterNode(center);

		}

		if (htHelpFile != null) {

			view.setHelpFile(htHelpFile);

		}

		if (htUrlAdr != null) {

			view.setUrlAdr(htUrlAdr);

		}

		// 14/11/2005

		if (htSearchType != null) {

			view.setSearchType(htSearchType.trim().toLowerCase());

		} else {

			view.setSearchType("line");

		}

		// *****

		if (htFont != null) {

			view.setFontNode(htFont);

		} else {

			view.setFontNode("Serif");

		}

		if (htFontSize != null) {

			view.setFontSizeNode(((new Integer(htFontSize)).intValue()));

		} else {

			view.setFontSizeNode(12);

		}

		if (htHomeImage != null) {

			imageH = getImage(getCodeBase(), htHomeImage);

			if (imageH != null) {

				view.setHomeImage(imageH);

			}
		} else {

		}

		if (htConfirmarImage != null) {

			imageO = getImage(getCodeBase(), htConfirmarImage);

			if (imageO != null) {

				view.setConfirmarImage(imageO);

			}
		} else {

		}

		if (htCancelarImage != null) {

			imageC = getImage(getCodeBase(), htCancelarImage);

			if (imageC != null) {

				view.setCancelarImage(imageC);

			}
		} else {

		}

		if (htAplicarImage != null) {

			imageA = getImage(getCodeBase(), htAplicarImage);

			if (imageA != null) {

				view.setAplicarImage(imageA);

			}
		} else {

		}

		if (htBackImage != null) {

			imageB = getImage(getCodeBase(), htBackImage);

			if (imageB != null) {

				view.setBackImage(imageB);

			}
		} else {

		}

		if (htHelpImage != null) {

			imageS = getImage(getCodeBase(), htHelpImage);

			if (imageS != null) {

				view.setHelpImage(imageS);

			}
		} else {

		}

		setLayout(new BorderLayout());

		setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));

		//setSize(new Dimension(800, 600));

		//add("Center", view);

		//setVisible(true);


		// Remoo do Frame Anterior

		int h;

		//setSize(new Dimension(800, 600));

		//add("Center", view);

		//setVisible(true);


		// Remoo do Frame Anterior

		int w;

		//setSize(new Dimension(800, 600));

		//add("Center", view);

		//setVisible(true);


		// Remoo do Frame Anterior

		int x;

		//setSize(new Dimension(800, 600));

		//add("Center", view);

		//setVisible(true);


		// Remoo do Frame Anterior

		int y;

		h = viewFrame.getHeight();

		w = viewFrame.getWidth();

		x = viewFrame.getX();

		y = viewFrame.getY();

		// Troquei em 07/07/2003 por este cdigo. Aqui eu armazeno viewFrame para depois remov-lo.

		viewFrameOld = viewFrame;

		// Fim Remoo

		viewFrame = new JFrame(root.getName());

		viewFrame.setContentPane(view);

		viewFrame.setSize(w, h);

		viewFrame.setLocation(x, y);

		viewFrame.setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));

		makeInterfaceEditor(viewFrame);

		view.setViewFrame(viewFrame);

		makeMenuBar(viewFrame);

		viewFrame.setJMenuBar(menubar);

		viewFrameOld.removeAll();

		viewFrameOld.dispose();

		viewFrame.setVisible(true);

	}


	/**
	 *  Description of the Method
	 *
	 * @param  node  Description of the Parameter
	 * @param  ind   Description of the Parameter
	 */

	public void percorre(HTFileNode node, int ind) {

		String b = "";

		for (int i = 0; i < ind; i++) {

			b = b + "    ";

		}

		//System.out.println(b + node.getID() + " " + node.getName() + " " + node.getColor());

		ntNos++;

		for (Enumeration e = node.children(); e.hasMoreElements(); ) {

			ntNos++;

			HTFileNode childNode = (HTFileNode) e.nextElement();

			if (!childNode.isLeaf()) {

				ind = ind + 1;

				percorre(childNode, ind);

				ind = ind - 1;

			} else {

				ind = ind + 1;

				b = "";

				for (int i = 0; i < ind; i++) {

					b = b + "    ";

				}

				//System.out.println(b+ " >> " + childNode.getID() + " " + childNode.getName() + " " + childNode.getHint());

				ind = ind - 1;

			}

		}

	}


	/**
	 *  Description of the Method
	 *
	 * @param  node   Description of the Parameter
	 * @param  first  Description of the Parameter
	 */

	public void convertPixes2Image(HTFileNode node, boolean first) {

		if (first && node.getPixels() != null) {

			node.setImageFromPixels();

		}

		for (Enumeration e = node.children(); e.hasMoreElements(); ) {

			HTFileNode childNode = (HTFileNode) e.nextElement();

			if (!childNode.isLeaf()) {

				if (childNode.getPixels() != null) {
					childNode.setImageFromPixels();
				}
				convertPixes2Image(childNode, false);

			} else {

				if (childNode.getPixels() != null) {

					childNode.setImageFromPixels();

				}
			}

		}

	}


	/**
	 *  Description of the Method
	 *
	 * @param  node  Description of the Parameter
	 * @param  nova  Description of the Parameter
	 */

	public void converte(HTFileNode node, HTFileNode nova) {
		for (Enumeration e = node.children(); e.hasMoreElements(); ) {
			HTFileNode childNodeV = (HTFileNode) e.nextElement();
			HTFileNode childNode = new HTFileNode();
			childNode.setID(childNodeV.getID());
			childNode.setName(childNodeV.getName());
			childNode.setHint(childNodeV.getHint());
			childNode.setColor(childNodeV.getColor());
			childNode.setURL(childNodeV.getURL());
			childNode.setTextColor(childNodeV.getTextColor());
			childNode.setNodeClientData(childNodeV.getNodeClientData());
			childNode.setLeafNode(childNodeV.isLeafNode());
			nova.addChild(childNode);
			System.out.println(childNode.getID());
			if (!childNodeV.isLeaf()) {
				converte(childNodeV, childNode);
			}
		}
	}


	/**
	 *  Description of the Method
	 */

	public void stop() {
		//conteudo	
/*		
		try {
			String folder = curDir;
			//System.getProperty("user.dir")+System.getProperty("file.separator");
			// Percorre rvore e resta alguns valores dos ns
			GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream(folder + htFile));
			ObjectOutputStream po = new ObjectOutputStream(zip);
			resetMark(root);
			nTentativas = 0;
			po.writeObject(root);
			zip.close();
			gravaVector();
		} catch (Exception e) {
			System.out.println("\nGrava de Objetos  :" + e.toString());
		}
*/
		destroy();
		//percorre(root, 0);
		//System.out.println("N. elementos: " + ntNos);
	}


	/**
	 *  Description of the Method
	 */

	public void undoRecupera() {
		undoControlAtual--;
		if (undoControlAtual < 0) {
			if (undoControlBase > 0) {
				undoControlAtual = 9;
			} else {
				undoControlAtual = 0;
				return;
			}
		}
		try {
			GZIPInputStream zip = new GZIPInputStream((new URL(getCodeBase(), "undo/" + htFile + "." + undoControlAtual)).openStream());
			ObjectInputStream pi = new ObjectInputStream(zip);
			root = (HTFileNode) pi.readObject();
			convertPixes2Image(root, true);
			zip.close();
		} catch (Exception e) {
			System.out.println("\nGrava de Objetos  :" + e.toString());
		}

		try {
			GZIPInputStream zip = new GZIPInputStream((new URL(getCodeBase(), "undo/" + htFile.toLowerCase().replaceAll(".htz", ".vec") + "." + undoControlAtual).openStream()));
			ObjectInputStream pi = new ObjectInputStream(zip);
			HTVector graphOld = (HTVector) pi.readObject();
			graph = new HTVector();
			for (int i = 0; i < graphOld.size(); i++) {
				HTPointGraph htp = (HTPointGraph) graphOld.elementAt(i);
				HTFileNode no1 = findNo(root,
						htp.getNode1().getID());
				HTFileNode no2 = findNo(root,
						htp.getNode2().getID());
				HTPointGraph v = new HTPointGraph(no1, no2);
				v.setArcName(htp.getArcName());
				v.setDirecionado(htp.getDirecionado());
				graph.add((Object) v);
			}
			zip.close();
		} catch (Exception e) {
			graph = new HTVector();
			System.out.println(e.toString());
		}
	}

	/**
	 *  Description of the Method
	 */
	public void undoGrava() {
		try {
			String folder = curDir;
			GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream(folder + "undo/" + htFile + "." + undoControlAtual));
			ObjectOutputStream po = new ObjectOutputStream(zip);
			po.writeObject(root);
			zip.close();
		} catch (Exception e) {
			System.out.println("\nGrava de Objetos  :" + e.toString());
		}
		if (graph != null) {
			String folder = "";
			try {
				folder = curDir;
				GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream(folder + "undo/" + htFile.toLowerCase().replaceAll(".htz", ".vec") + "." + undoControlAtual));
				ObjectOutputStream po = new ObjectOutputStream(zip);
				po.writeObject(graph);
				zip.close();
			} catch (Exception e) {
				System.out.println("\nGrava de Objetos Vector :" + e.toString());
			}
			System.out.println(":: Vector Gravado em ::" + folder + htFile);
		}
		undoControlAtual++;
		if (undoControlAtual > 9) {
			undoControlBase = 1;
			undoControlAtual = 0;
		}
	}


	/**
	 *  Description of the Method
	 */
	public void gravaVector() {
		if (graph != null) {
			String folder = "";
			try {
				folder = curDir;
				GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream(folder + htFile.toLowerCase().replaceAll(".htz", ".vec")));
				ObjectOutputStream po = new ObjectOutputStream(zip);
				po.writeObject(graph);
				zip.close();
			} catch (Exception e) {
				System.out.println("\nGrava de Objetos Vector :" + e.toString());
			}
			System.out.println(":: Vector Gravado em ::" + folder + htFile);
		}
	}

	/**
	 *  Description of the Method
	 */
	public void grava() {
		String folder = "";
		try {
			folder = curDir;
			GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream(folder + htFile));
			ObjectOutputStream po = new ObjectOutputStream(zip);
			resetMark(root);
			nTentativas = 0;
			po.writeObject(root);
			po.flush();
			zip.close();
			gravaVector();
		} catch (Exception e) {
			System.out.println("\nGrava de Objetos  :" + e.toString());
		}
		System.out.println(":: Hipertree Gravada em ::" + folder + htFile);
	}

	// Silvio 19/09/2006

	static int nTentativas = 0;

	static int nThreads = 0;

	static int nQueb = 0;


	/**
	 *  Description of the Method
	 *
	 * @param  node  Description of the Parameter
	 */

	public void resetMark(HTFileNode node) {
		for (Enumeration e = node.children(); e.hasMoreElements(); ) {
			HTFileNode childNode = (HTFileNode) e.nextElement();
			if (!childNode.isLeaf()) {
				childNode.setEspecialMark(false);
				childNode.setHasData(false);
				resetMark(childNode);
			} else {
				childNode.setEspecialMark(false);
				childNode.setHasData(false);
			}
		}
	}


	/**
	 *  Description of the Class
	 *
	 * @author     silvio
	 * @created    October 1, 2006
	 */

	class verThread implements Runnable {

		//extends Thread {

		String link;

		HTFileNode childNode;

		int nTentativas;


		/**
		 *Constructor for the verThread object
		 *
		 * @param  ll     Description of the Parameter
		 * @param  child  Description of the Parameter
		 * @param  nt     Description of the Parameter
		 */

		verThread(String ll, HTFileNode child, int nt) {

			this.link = ll;

			this.childNode = child;

			this.nTentativas = nt;

		}


		/**
		 *  Main processing method for the verThread object
		 */

		public void run() {

			String cor = childNode.getColor();

			try {

				if (getNThreads() <= 2) {

					Thread.sleep(1000);

				}

				if ((nTentativas <= 1) || (nTentativas > 1 && childNode.getEspecialMark())) {

					URL encontrado = new URL(link);

					BufferedReader in = new BufferedReader(new InputStreamReader(encontrado.openStream()));

					if (in.toString().toLowerCase().indexOf("404") >= 0 && in.toString().toLowerCase().indexOf("not") >= 0 && in.toString().toLowerCase().indexOf("found") >= 0) {

						childNode.setEspecialMark(true);

					}

					in.close();

					childNode.setEspecialMark(false);

				}

				decnThreads();

			} catch (Exception e2) {

				decnThreads();

				incQueb();

				childNode.setEspecialMark(true);

			}

		}

	}


	/**
	 *  Gets the nThreads attribute of the HTApplet class
	 *
	 * @return    The nThreads value
	 */

	static int getNThreads() {

		return (nThreads);
	}


	/**
	 *  Description of the Method
	 */

	static void decnThreads() {

		nThreads--;

		view.setNThreads(nThreads);

		if (nThreads == 0) {

			view.enableVerificarLinks();

			view.repaint();

			if (nTentativas <= 1) {

				putDialog("Execuo " + nTentativas + ". Processo de verificao dos 'links' est finalizado. Foram encontrados " + nQueb + " 'links' quebrados.");

			} else {

				putDialog("Execuo " + nTentativas + ". Processo de verificao dos 'links' est finalizado. Foram encontrados " + nQueb + " 'links' quebrados." + "Obs: apenas os  'links' quebrados anteriormente foram verificados nesta execuo");

			}

		} else {

			view.repaint();

		}

	}


	/**
	 *  Description of the Method
	 */

	static void incQueb() {

		nQueb++;

	}

	//bruno

	String[] Endereco = new String[50];
	// String que armazena os enderecos lidos

	String[] NomeFantasia = new String[50];
	// String que armazena os Nomes dos enderecos lidos

	int[] PossueNome = new int[50];

	// Variavel que indica se o endereco possue um NomeFantasia

	/**
	 *  Description of the Method
	 *
	 * @param  node  Description of the Parameter
	 * @param  ind   Description of the Parameter
	 */

	public void verificaLinks1(HTFileNode node, int ind) {

		for (Enumeration e = node.children(); e.hasMoreElements(); ) {

			if (continua == false) {

				break;
			}

			HTFileNode childNode = (HTFileNode) e.nextElement();

			String link = childNode.getURL();

			// Bruno,

			PercorreURL(link);

			// percorre todos os endereco - Endereco[k] por link

			for (int k = 0; k < ContaLinks(link); k++) {

				//if (link != null && link.trim().length() > 4) {

				if (Endereco[k] != null && Endereco[k].trim().length() > 4) {

					try {

						//childNode.setEspecialMark(true);

						String base = view.getUrlAdr();

						if ((base.length() > 2) && (Endereco[k].toLowerCase().indexOf("http:") < 0)) {

							if ((Endereco[k].charAt(0) != '/') && (base.charAt(base.length() - 1) != '/')) {

								Endereco[k] = base + "/" + Endereco[k];

							} else {

								Endereco[k] = base + Endereco[k];

							}

						}

						nThreads++;

						Thread t = new Thread(new verThread(Endereco[k], childNode, nTentativas));

						t.start();

					} catch (Exception e2) {

					}

				} else {

				}

			}

			if (!childNode.isLeaf()) {

				ind = ind + 1;

				verificaLinks1(childNode, ind);

				ind = ind - 1;

			}
		}

	}

	//bruno

	// Funcao que percorre o URL recebido e separa os enderecos dos nomes

	/**
	 *  Description of the Method
	 *
	 * @param  URLs  Description of the Parameter
	 */
	private void PercorreURL(String URLs) {

		String Linha;

		int Inicio = 0;

		int InicioNome = 0;

		int FimNome = 0;

		int Posicao = 0;

		// Verifica se existe o "@!" no final da string

		if (URLs == null || URLs.length() < 2 || (URLs.charAt(URLs.length() - 2) != '@' && URLs.charAt(URLs.length() - 1) != '!')) {

			URLs = URLs + "@!";

		}

		if (URLs.length() > 2) {

			// Percorre a string de URLs e monta a janela PopUp

			for (int h = 0; h < URLs.length(); h++) {

				// Quando encontrar o @, um link  gerado

				if ((h + 1) < URLs.length()) {

					if ((URLs.charAt(h) == '@' && URLs.charAt(h + 1) == '!') || h == URLs.length() - 1) {

						// Pega a parte da linha que contem o proximo Nome e Link

						Linha = URLs.substring(Inicio,
								h + 1);

						// Procura o inicio e o final do nome

						for (int k = 0; k < Linha.length(); k++) {

							//Inicio

							if (Linha.charAt(k) == '`' && Linha.charAt(k + 1) == '(') {

								InicioNome = k + 2;

								PossueNome[Posicao] = 1;

							}

							//Fim

							if (Linha.charAt(k) == ')' && Linha.charAt(k + 1) == '`') {

								FimNome = k;

							}
						}

						// Se existe o nome, coloca ele no NomeFantasia, se nao coloca o link no NomeFantasia

						if (PossueNome[Posicao] == 1) {

							NomeFantasia[Posicao] = Linha.substring(InicioNome, FimNome).trim();

							//.replace(")", "").replace("!", "")

							//URL  o comeco da string Endereco ate o comeco do InicioNome - 1

							Endereco[Posicao] = Linha.substring(0, InicioNome - 2).replace("!", "").trim();

							//.replace("!", "").replace("(", "")

						} else {

							// Quando nao existe nome, o final eh o tamanho do Endereco

							Endereco[Posicao] = NomeFantasia[Posicao] = Linha.substring(0, Linha.length() - 1).replace("!", "").trim();

							//

						}

						// Posicao na string de URL que deve comecar o proximo endereco

						Inicio = h + 1;

						Posicao++;

					}
				}
			}

		}
	}


	/*
	 *  Conta quantos links tem na string
	 */
	/**
	 *  Description of the Method
	 *
	 * @param  URLs  Description of the Parameter
	 * @return       Description of the Return Value
	 */
	int ContaLinks(String URLs) {

		int NumLinks = 0;

		if (URLs != null) {

			for (int i = 0; i < URLs.length(); i++) {

				if (URLs.charAt(i) == '@' && URLs.charAt(i + 1) == '!') {

					NumLinks++;

				}
			}

			return NumLinks;
		} else {

			System.out.println("Nao possue URL");

			return 0;
		}

	}

	//fim bruno

	private boolean continua = true;

	private ThreadGroup grupo;


	/**
	 *  Description of the Method
	 */

	public void verificaLinks() {

		if ((view != null) && (nThreads == 0)) {

			view.disableVerificarLinks();

			nQueb = 0;

			nTentativas++;

			verificaLinks1(root, 0);

		}
	}


	/**
	 *  Description of the Class
	 *
	 * @author     silvio
	 * @created    October 1, 2006
	 */

	class impThread implements Runnable {

		//extends Thread {

		HTFileNode root;


		/**
		 *Constructor for the impThread object
		 *
		 * @param  child  Description of the Parameter
		 */

		impThread(HTFileNode child) {

			this.root = child;

		}


		/**
		 *  Main processing method for the impThread object
		 */

		public void run() {

			try {

				SelectableTree folder = new SelectableTree(root);
			} catch (Exception e2) {

			}

		}

	}


	/**
	 *  Description of the Method
	 */

	public void folderTree() {

		Thread t = new Thread(new impThread(root));

		t.start();

		//SelectableTree folder = new SelectableTree(root);

	}


	/**
	 *  Description of the Method
	 */
	public void configNavegador() {

		Frame f = new Frame("Navegador");

		HTDialogNavegador navegador = new HTDialogNavegador(f, true,
				view, htFile, this);

		navegador.show();

	}


	/**
	 *  Description of the Method
	 *
	 * @param  img  Description of the Parameter
	 */
	public void sethtBackImage(String img) {

		htBackImage = img;

	}


	/**
	 *  Description of the Method
	 *
	 * @return    Description of the Return Value
	 */
	public String gethtBackImage() {

		return htBackImage;
	}


	/**
	 *  Description of the Method
	 *
	 * @param  cor  Description of the Parameter
	 */
	public void sethtBackColor(String cor) {

		htBackColor = cor;

	}


	/**
	 *  Description of the Method
	 *
	 * @return    Description of the Return Value
	 */
	public String gethtBackColor() {

		return htBackColor;
	}


	/**
	 *  Description of the Method
	 *
	 * @return    Description of the Return Value
	 */
	public String gethtGraphColor() {

		return htGraphColor;
	}


	/**
	 *  Description of the Method
	 *
	 * @param  cor  Description of the Parameter
	 */
	public void sethtLinkColor(String cor) {

		htLinkColor = cor;

	}


	/**
	 *  Description of the Method
	 *
	 * @return    Description of the Return Value
	 */
	public String gethtLinkColor() {

		return htLinkColor;
	}


	/**
	 *  Description of the Method
	 *
	 * @param  cor  Description of the Parameter
	 */
	public void sethtSearchColor(String cor) {

		htSearchColor = cor;

	}


	/**
	 *  Description of the Method
	 *
	 * @return    Description of the Return Value
	 */
	public String gethtSearchColor() {

		return htSearchColor;
	}


	/**
	 *  Description of the Method
	 *
	 * @param  cor  Description of the Parameter
	 */
	public void sethtHintColor(String cor) {

		htHintColor = cor;

	}


	/**
	 *  Description of the Method
	 *
	 * @return    Description of the Return Value
	 */
	public String gethtHintColor() {

		return htHintColor;
	}


	/**
	 *  Description of the Method
	 *
	 * @param  cor  Description of the Parameter
	 */
	public void sethtGraphColor(String cor) {

		htGraphColor = cor;

	}


	/**
	 *  Description of the Method
	 *
	 * @param  F  Description of the Parameter
	 */
	public void sethtFontNode(String F) {

		htFont = F;

	}


	/**
	 *  Description of the Method
	 *
	 * @param  S  Description of the Parameter
	 */
	public void sethtFontSizeNode(String S) {

		htFontSize = S;

	}


	/**
	 *  Description of the Method
	 *
	 * @param  texto  Description of the Parameter
	 */

	static void putDialog(String texto) {

		// Create an instance of InfoDialog, with title and message specified

		HTDialogYesNo d = new HTDialogYesNo(viewFrame, "Informao", texto, null, "OK", null);

		// Register an action listener for the dialog.  This one just prints

		// the results out to the console.

		d.addActionListener(
			new ActionListener() {

				public void actionPerformed(ActionEvent e) {

					String answer = e.getActionCommand();

					if (answer.equals("yes")) {

						//continua=false;

					}
				}

			});

		d.show();

	}

	static HTFileNode noCraw;

	static HTCrawling craw;

	static String idCenter = null;

	static int nCrow = 0;


	/**
	 *  Description of the Method
	 */
	public void crowlingFeedBack() {

		view.setNCrow(++nCrow);

		if (nCrow % 10 == 0) {

			view.repaint();

		}
	}

	/*
	 *  public void  webCrawling(String id) {
	 *  idCenter=id;
	 *  HTFileNode pai = findNo(root,id);
	 *  if (pai != null) {
	 *  nCrow=0;
	 *  view.disableCrawling();
	 *  view.setNCrow(0);
	 *  Object[] options = { "OK", "CANCELAR" };
	 *  String s = (String)JOptionPane.showInputDialog(
	 *  viewFrame,
	 *  "Entre com a URL a ser percorrida:\n",
	 *  "Web-Crawling",
	 *  JOptionPane.PLAIN_MESSAGE,
	 *  null,
	 *  null,
	 *  "http://");
	 *  if ((s.toUpperCase().trim().indexOf("HTTP://")<0) ||(s.toUpperCase().trim().indexOf("FILE://")>=0)) {
	 *  HTFileNode rootF = new HTFileNode();
	 *  Date data = new Date();
	 *  rootF.setID("_"+data.getTime()+"_F");
	 *  treeFromFolder tf = new treeFromFolder();
	 *  String path = s.replaceAll("file://"," ");
	 *  path = path.replaceAll("FILE://"," ");
	 *  path = path.replaceAll("File://"," ");
	 *  try {
	 *  noCraw=pai;
	 *  rootF.setName(path.trim());
	 *  rootF.setLeafNode(false);
	 *  rootF.setColor("0xA0B200");
	 *  rootF.setTextColor("0x000000");
	 *  rootF.setHint(path.trim());
	 *  rootF.setURL("");
	 *  rootF.setHasHint(false);
	 *  rootF.setEspecialMark(false);
	 *  tf.countFiles(path.trim(), rootF);
	 *  view.enableCrawling();
	 *  noCraw.setLeafNode(false);
	 *  noCraw.addChild(rootF);
	 *  noCraw.setHasHint(false);
	 *  noCraw.setEspecialMark(false);
	 *  reLoad(idCenter);
	 *  }catch(Exception e){
	 *  view.enableCrawling();
	 *  }
	 *  }
	 *  else {
	 *  int n = nChilds(pai);
	 *  noCraw=pai;
	 *  craw = new HTCrawling();
	 *  craw.setApplet(this);
	 *  craw.init(s,id+"."+s+"."+n,"5");
	 *  }
	 *  }
	 *  }
	 */
	CDialog cdialog;


	/**
	 *  Description of the Method
	 *
	 * @param  id  Description of the Parameter
	 */
	public void webCrawling(String id) {

		idCenter = id;

		HTFileNode pai = findNo(root, id);

		if (pai != null) {

			cdialog = new CDialog(this, viewFrame);

		}
	}


	/**
	 *  Description of the Method
	 */
	public void execCrowling() {

		String id = idCenter;

		String s = cdialog.getURL();

		String deep = cdialog.getDEEP();

		String add = cdialog.getADD();

		HTFileNode pai = findNo(root, id);

		if (pai != null) {

			nCrow = 0;

			view.disableCrawling();

			view.setNCrow(0);

			if ((s.toUpperCase().trim().indexOf("HTTP://") < 0) || (s.toUpperCase().trim().indexOf("FILE://") >= 0)) {

				HTFileNode rootF = new HTFileNode();

				Date data = new Date();

				rootF.setID("_" + data.getTime() + "_F");

				treeFromFolder tf = new treeFromFolder();

				String path = s.replaceAll("file://", " ");

				path = path.replaceAll("FILE://", " ");

				path = path.replaceAll("File://", " ");

				try {

					noCraw = pai;

					rootF.setName(path.trim());

					rootF.setLeafNode(false);

					rootF.setColor("0xA0B200");

					rootF.setTextColor("0x000000");

					rootF.setHint(path.trim());

					rootF.setURL("");

					rootF.setHasHint(false);

					rootF.setEspecialMark(false);

					tf.countFiles(path.trim(), rootF);

					view.enableCrawling();

					noCraw.setLeafNode(false);

					noCraw.addChild(rootF);

					noCraw.setHasHint(false);

					noCraw.setEspecialMark(false);

					reLoad(idCenter);

				} catch (Exception e) {

					view.enableCrawling();

				}

			} else {

				int n = nChilds(pai);

				noCraw = pai;

				craw = new HTCrawling();

				craw.setApplet(this);

				craw.init(s, id + "." + s + "." + n, deep);

			}

		}
	}


	/**
	 *  Sets the newNodes attribute of the HTApplet object
	 *
	 * @param  node  The new newNodes value
	 */
	public void setNewNodes(HTFileNode node) {

		nCrow = 0;

		view.setNCrow(0);

		view.enableCrawling();

		noCraw.setLeafNode(false);

		noCraw.addChild(node);

		noCraw.setHasHint(false);

		noCraw.setEspecialMark(false);

		reLoad(idCenter);

	}


	/**
	 *  Description of the Method
	 *
	 * @param  no  Description of the Parameter
	 * @param  id  Description of the Parameter
	 * @return     Description of the Return Value
	 */
	public static HTFileNode findNo(HTFileNode no, String id) {

		if (no.getID().trim().equals(id.trim())) {

			return (no);
		}

		return buscaNo(no, id);
	}


	/**
	 *  Description of the Method
	 *
	 * @param  node  Description of the Parameter
	 * @param  id    Description of the Parameter
	 * @return       Description of the Return Value
	 */

	public static HTFileNode buscaNo(HTFileNode node, String id) {

		for (Enumeration e = node.children(); e.hasMoreElements(); ) {

			HTFileNode childNode = (HTFileNode) e.nextElement();

			if (childNode.getID().trim().equals(id.trim())) {

				return (childNode);
			}

			if (!childNode.isLeaf()) {

				HTFileNode ret = buscaNo(childNode, id);

				if (ret != null) {

					return (ret);
				}
			}
		}

		return (null);
	}


	/**
	 *  Description of the Method
	 *
	 * @param  node  Description of the Parameter
	 * @return       Description of the Return Value
	 */
	public int nChilds(HTFileNode node) {
		int n = 0;
		for (Enumeration e = node.children(); e.hasMoreElements(); ) {
			HTFileNode childNode = (HTFileNode) e.nextElement();
			n++;
		}
		return (n);
	}

	// Silvio

	/**
	 *  Description of the Method
	 *
	 * @return    Description of the Return Value
	 */

	public boolean hasUndo() {
		if ((undoControlAtual == 0) && (undoControlBase == 0)) {
			return false;
		} else {
			return true;
		}
	}

	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */

	public void actionPerformed(ActionEvent e) {
	}

	/**
	 *  Sets the backColorAp attribute of the HTApplet object
	 */
	public void setBackColorAp() {
		viewFrame.setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));
		view.setViewFrame(viewFrame);
	}

	/**
	 *  Gets the htmlName attribute of the HTApplet object
	 *
	 * @return    The htmlName value
	 */
	public String getHtmlName() {
		return this.getDocumentBase().toString().substring(this.getDocumentBase().toString().lastIndexOf("/") + 1, this.getDocumentBase().toString().length());
	}

	// 12/09/2008
	/**
	 *  Sets the lineGraph attribute of the HTApplet object
	 *
	 * @param  n  The new lineGraph value
	 */
	public void setLineGraph(boolean n) {
		lineGraph = n;
	}

	/**
	 *  Gets the lineGraph attribute of the HTApplet object
	 *
	 * @return    The lineGraph value
	 */
	public boolean getLineGraph() {
		return lineGraph;
	}

	/**
	 *  Description of the Method
	 *
	 * @param  no        Description of the Parameter
	 * @param  filename  Description of the Parameter
	 * @param  nImporte  Description of the Parameter
	 */
	void loadTreeAt(HTFileNode no, String filename, int nImporte) {
		try {
			GZIPInputStream zip = new GZIPInputStream((new URL(getCodeBase(), filename)).openStream());
			ObjectInputStream pi = new ObjectInputStream(zip);
			HTFileNode root = (HTFileNode) pi.readObject();
			convertPixes2Image(root, true);
			root.setID(nImporte + "-" + filename + "-" + root.getID());
			HTFileNode rootN = new HTFileNode(root);
			no.setLeafNode(false);
			if (rootN.getPixels() != null) {
				rootN.setImageFromPixels();
			}
			no.addChild(rootN);
			converteID(root, filename, rootN, nImporte);
			convertPixes2Image(no, true);
			zip.close();
		} catch (Exception e) {
			System.out.println(e.toString());
		}
		try {
			GZIPInputStream zip = new GZIPInputStream((new URL(getCodeBase(), filename.replaceAll(".htz", ".vec")).openStream()));
			ObjectInputStream pi = new ObjectInputStream(zip);
			HTVector graphOld = (HTVector) pi.readObject();
			for (int i = 0; i < graphOld.size(); i++) {
				HTPointGraph htp = (HTPointGraph) graphOld.elementAt(i);
				HTFileNode no1 = findNo(root,
						nImporte + "-" + filename + "-" + htp.getNode1().getID());
				HTFileNode no2 = findNo(root,
						nImporte + "-" + filename + "-" + htp.getNode2().getID());
				if (no1 != null && no2 != null) {
					HTPointGraph v = new HTPointGraph(no1, no2);
					v.setDirecionado(htp.getDirecionado());
					v.setArcName(htp.getArcName());
					graph.add((Object) v);
				}
			}
			zip.close();
		} catch (Exception e) {
			System.out.println(e.toString());
		}
	}

	/**
	 *  Description of the Method
	 *
	 * @param  node      Description of the Parameter
	 * @param  filename  Description of the Parameter
	 * @param  root      Description of the Parameter
	 * @param  nImporte  Description of the Parameter
	 */

	public void converteID(HTFileNode node, String filename, HTFileNode root, int nImporte) {
		for (Enumeration e = node.children(); e.hasMoreElements(); ) {
			HTFileNode childNodeV = (HTFileNode) e.nextElement();
			HTFileNode rootN = new HTFileNode(childNodeV);
			rootN.setID(nImporte + "-" + filename + "-" + rootN.getID());
			if (rootN.getPixels() != null) {
				rootN.setImageFromPixels();
			}
			root.addChild(rootN);
			if (!childNodeV.isLeaf()) {
				converteID(childNodeV, filename, rootN, nImporte);
			}
		}
	}

	int nImporte = 0;

	/**
	 *  Description of the Method
	 *
	 * @param  node  Description of the Parameter
	 */
	void verificaNImporte(HTFileNode node) {
		for (Enumeration e = node.children(); e.hasMoreElements(); ) {
			HTFileNode childNodeV = (HTFileNode) e.nextElement();
			int k = childNodeV.getID().indexOf("-");
			if (k >= 0) {
				try {
					int n = new Integer(childNodeV.getID().substring(0, k)).intValue();
					if (n > nImporte) {
						nImporte = n;
					}
				} catch (Exception e1) {
					System.out.println(e1.toString());
				}
			}
			if (!childNodeV.isLeaf()) {
				verificaNImporte(childNodeV);
			}
		}

	}
	
	void verificaNImportePub() {
		verificaNImporte(root);
	}

	/**
	 *  Description of the Method
	 *
	 * @return    Description of the Return Value
	 */
	int getnImporte() {
		return nImporte;
	}

}


