/*
 * Shapeform.java
 *
 * Created on 5 de Agosto de 2008, 16:20
 */

import java.awt.Color;
import java.awt.Graphics;

import java.awt.Polygon;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.awt.*;

/**
 *
 * @author  rafael
 */
public class HTDialogShapes extends javax.swing.JDialog {

    Polygon p[]    = new Polygon[64];
    Polygon poli[] = new Polygon[64];
    int[] x = new int[64];
    int[] y = new int[64];
    HTLoadSVG svg;
    private static int Selecionado = 0; // Variavel que guarda o valor o poligono selecionado
    private static int posicao = 15; // variavel usada para exibir os poligonos de 15 em 15
    private static int i = 0; //variavel usada para saber a partir de qual poligono devera ser desenhado
    private static boolean focus = true;
    int k = 0;
    private static String nomeArqSimbolos;// arquivo svg padrão
    public HTDrawNode model;

    /** Creates new form HTDialogShapes */
    public HTDialogShapes(Frame parent, String path) {
        super(parent, true);

        try {
            svg = new HTLoadSVG(path + "dataflow.svg");
            nomeArqSimbolos = "dataflow.svg";
        } catch (Exception e) {
            System.out.println("Erro : " + e.toString());
        }

        
        initComponents();
	  geraPoligonos();
        try {
            Graphics graphics = jPanel1.getGraphics();
            drawShape(graphics, getPosicao(), i);
            desenha_botao();
        } catch (IOException ex) {
		System.out.println(ex.toString());
            //Logger.getLogger("Erro : formComponentMoved");
        }

	  
    }

    public void setNode(HTDrawNode node) {
        model = node;
        setTitle("Forma para o no " + model.getName());
       nomeArqSimbolos = model.getPath() + "dataflow.svg";
	 
        System.out.println("Arquivo default : " + nomeArqSimbolos);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        btnAbrir = new javax.swing.JButton();
        btnOK = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        btnSeta = new javax.swing.JButton();

        setAlwaysOnTop(true);
        setName("ShapeForm"); // NOI18N
        setResizable(false);
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {

            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
                formWindowGainedFocus(evt);
            }

            public void windowLostFocus(java.awt.event.WindowEvent evt) {
            }
        });
        addComponentListener(new java.awt.event.ComponentAdapter() {

            public void componentMoved(java.awt.event.ComponentEvent evt) {
                formComponentMoved(evt);
            }
        });

        btnAbrir.setText("Abrir");
        btnAbrir.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAbrirActionPerformed(evt);
            }
        });

        btnOK.setText("OK");
        btnOK.setEnabled(false);
        btnOK.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOKActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
                jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(jPanel2Layout.createSequentialGroup().addContainerGap().addComponent(btnAbrir, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addComponent(btnOK, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE).addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)));
        jPanel2Layout.setVerticalGroup(
                jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(jPanel2Layout.createSequentialGroup().addContainerGap().addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(btnAbrir).addComponent(btnOK)).addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)));

        //new javax.swing.JPanel()
        jPanel1.addMouseListener(new java.awt.event.MouseAdapter() {

            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPanel1MouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGap(0, 523, Short.MAX_VALUE));
        jPanel1Layout.setVerticalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGap(0, 264, Short.MAX_VALUE));

        btnSeta.setText(">");
        btnSeta.setAlignmentY(0.0F);
        btnSeta.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        btnSeta.setEnabled(false);
        btnSeta.setVisible(false);
        btnSeta.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSetaActionPerformed(evt);
            }
        });

       javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
        layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup().addGap(200, 200, 200).addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 166, javax.swing.GroupLayout.PREFERRED_SIZE).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 173, Short.MAX_VALUE).addComponent(btnSeta, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)).addGroup(layout.createSequentialGroup().addGap(19, 19, 19).addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).addContainerGap(18, Short.MAX_VALUE)));
        layout.setVerticalGroup(
        layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(layout.createSequentialGroup().addContainerGap().addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING).addComponent(btnSeta, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE).addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))));

        pack();
	  repaint();
    }// </editor-fold>//GEN-END:initComponents

    private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOKActionPerformed
        //Botão OK
        setIndice(Selecionado); // define qual poligono esta selecionado
        hide();

    }//GEN-LAST:event_btnOKActionPerformed

    private void btnAbrirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAbrirActionPerformed
        // Botão Abrir
        JFileChooser seleciona = new JFileChooser();
        seleciona.setFileFilter(new FileNameExtensionFilter("SVG", "SVG"));
        seleciona.setPreferredSize(jPanel1.getSize());
        int resposta = seleciona.showOpenDialog(this);
        if (resposta == JFileChooser.APPROVE_OPTION) {
            Selecionado = 0;
            posicao = 15;
            i = 0;
            setEndereco(seleciona.getSelectedFile().getAbsolutePath());//Define o ultimo endereço que foi aberto
            setFocus(false);
            desenha_botao();
        }
        if (resposta == JFileChooser.CANCEL_OPTION) {
            setFocus(false);
        }

    }//GEN-LAST:event_btnAbrirActionPerformed

    private void jPanel1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MouseClicked
        //Pega a posição do clique do mouse no componente jPanel1
        Graphics g = jPanel1.getGraphics();
        for (k = getI(); k < svg.getNumeroSimbolos(); k++) {
            if (p[k].contains(evt.getX(), evt.getY()) && (k - getI()) < 15) //verificar se k-i < que 15 para deixar clicar somente nos poligonos presentes nakela tela
            {
                // se na posição do clique do mouse EXISTIR um poligono
                if ((getPosicao() - getIndice()) > 0 && (getPosicao() - getIndice()) <= 15) {
                    //verifica para ver se o poligono esta entre os 15 que estão sendo exibidos
                    g.setColor(Color.BLUE); // deseleciona o ultimo poligono selecionado
                    g.fillPolygon(p[Selecionado]);
                    g.setColor(Color.black);
                    g.drawPolygon(p[Selecionado]);
                    g.setColor(Color.ORANGE);
                    g.drawString("TEXTO", x[Selecionado], y[Selecionado] + 20);
                }
                g.setColor(Color.ORANGE); // seleciona o novo poligono
                g.fillPolygon(p[k]);
                g.setColor(Color.black);
                g.drawPolygon(p[k]);
                g.setColor(Color.BLUE);
                g.drawString("TEXTO", x[k], y[k] + 20);
                Selecionado = k;
                break;
            }
        }
    }//GEN-LAST:event_jPanel1MouseClicked

    private void btnSetaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSetaActionPerformed
        //GEN-LAST:event_btnSetaActionPerformed
        try {
            //Botão [>]
            setFocus(true);
            avanca_lista();
        } catch (IOException ex) {
		System.out.println(ex.toString());
           // Logger.getLogger("Erro : Botao [>]");
        }
    }

    private void formComponentMoved(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentMoved
        try {
            Graphics graphics = jPanel1.getGraphics();/*
            drawShape(graphics, posicao, i);//GEN-LAST:event_formComponentMoved
             */
            drawShape(graphics, getPosicao(), i);
            desenha_botao();
        } catch (IOException ex) {
		System.out.println(ex.toString());
            //Logger.getLogger("Erro : formComponentMoved");
        }

    }

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
        try {
            Graphics graphics = jPanel1.getGraphics();
            drawShape(graphics, posicao, i);
            desenha_botao();
        } catch (IOException ex) {
		System.out.println(ex.toString());
            //Logger.getLogger("Erro : formWindowGainedFocus");
        }

        setFocus(false);
    }//GEN-LAST:event_formWindowGainedFocus

    void atualiza() {
        Graphics graphics = jPanel1.getGraphics();
        jPanel1.invalidate();
        jPanel1.update(graphics);
       

    }

    void desenha_selecionado(Graphics g) {
        //Graphics g = jPanel1.getGraphics();
        if ((getPosicao() - getIndice()) > 0 && (getPosicao() - getIndice()) <= 15) { // verifica para ver se o poligono esta entre os 15 que estão sendo exibidos
            g.setColor(Color.ORANGE);
            g.fillPolygon(p[Selecionado]);
            g.setColor(Color.black);
            g.drawPolygon(p[Selecionado]);

        }
    }

    void avanca_lista() throws IOException {
        Graphics graphics = jPanel1.getGraphics();
        jPanel1.update(graphics);

        setI(getI() + 15);//i = i + 15; // adiciona 15 em i para poder ser desenhado os proximos 15 poligonos a partir desse i
        setPosicao(getPosicao() + 15);//posicao = posicao + 15; //desenha 15 poligono
        if (i > svg.getNumeroSimbolos()) {// se i maior que o numero de simbolos
            setI(0); // torna a lista circular
            setPosicao(15);
            jPanel1.update(graphics);
        }
        drawShape(graphics, getPosicao(), i);
    }

    void drawShape(Graphics g, int posicao, int i) throws IOException {
        //Desenha os poligonos
        int largura = 80;
        int posicaox = 0;
        int posicaoy = 10;
        int contador = 0;
	try {
		
        for (; i < posicao; i++) {  //enquanto i for menor que posicao desenha, posicao é uma variavel global e é incrementado de 15 em 15 no metodo avanca_lista
		
	    if (i >= svg.getNumeroSimbolos())
		    return;
	    
            p[i] = new Polygon();
            int[] normX = svg.getVetx(i, largura, posicaox);
            int[] normY = svg.getVety(i, largura, posicaoy);
            int X = svg.getRectx(i, largura, posicaox);
            int Y = svg.getRecty(i, largura, posicaoy);

            g.setColor(Color.BLUE);
            //g.fillPolygon(p[i]);
            g.fillPolygon(normX, normY, (int) svg.getNumeroCordenada(i));
            g.setColor(Color.black);
            g.drawPolygon(normX, normY, (int) svg.getNumeroCordenada(i));
            x[i] = X;
            y[i] = Y;
            g.setColor(Color.ORANGE);
            g.drawString("TEXTO", X, Y + 20);
            for (int j = 0; j < svg.getNumeroCordenada(i); j++) {
                p[i].addPoint(normX[j], normY[j]);
            }
            contador++;
            if (contador % 5 == 0) { // se tiver exibido 5 poligonos
                posicaox = 0; // "pula" para a linha de baixo
                posicaoy = posicaoy + (largura + 5);
            } else {
                posicaox = posicaox + (largura + 30); // se não vai exibindo um do lado do outro
            }
        }
        desenha_selecionado(g);
	}
	catch(Exception e) {
		System.out.println(i + " " + posicao + " ");
		System.out.println(e.toString());	
	}
    }

    void geraPoligonos() {
        for (int i = 0; i < svg.getNumeroSimbolos(); i++) { 	// Inicializa o vetor de poligonos
            poli[i] = new Polygon();
            int[] normX = svg.getVetx(i, 1, 1);
            int[] normY = svg.getVety(i, 1, 1);
            for (int j = 0; j < svg.getNumeroCordenada(i); j++) {
                poli[i].addPoint(normX[j], normY[j]);
            }
        }
    }

    public Polygon getPoligono(int indice, int posicaox, int posicaoy, int largura) {
        Polygon p1 = new Polygon();
        int[] normX = svg.getVetx(indice, largura, posicaox);
        int[] normY = svg.getVety(indice, largura, posicaoy);
        for (int j = 0; j < svg.getNumeroCordenada(indice); j++) {
            p1.addPoint(normX[j], normY[j]);
        }
        return p1;
    }

    void desenha_botao() // da enable no botão OK e no [>]
    {
        if (svg.getNumeroSimbolos() > 14) {
            btnSeta.setVisible(true);
            btnSeta.setEnabled(true);
            btnOK.setEnabled(true);
        }
        if (svg.getNumeroSimbolos() < 14) {
            btnSeta.setVisible(false);
            btnSeta.setEnabled(false);
            btnOK.setEnabled(true);
        }
    }

    int getIndice() {
        return Selecionado;
    }

    void setIndice(int Indice) {
        model.setIndicePoligono(Indice);
        Selecionado = Indice;
    }

    int getPosicao() {
        return posicao;
    }

    void setPosicao(int p) {
        posicao = p;
    }

    void setI(int I) {
        i = I;
    }

    int getI() {
        return i;
    }

    void setFocus(boolean f) {
        focus = f;
    }

    boolean getFocus() {
        return focus;
    }

    String getEndereco() {
        return nomeArqSimbolos;
    }

    void setEndereco(String endereco) {
        nomeArqSimbolos = endereco;
    }

    public Polygon getPoli() {
        Polygon pol = new Polygon();
        pol = poli[getIndice()];
        return pol;
    }

    public int getRectx(int i, int largura, int posicaox) {
        return svg.getRectx(i, largura, posicaox);
    }

    public int getRecty(int i, int largura, int posicaoy) {
        return svg.getRecty(i, largura, posicaoy);
    }

    int getWidth(int i, int largura) {
        return svg.getWidth(i, largura);
    }

    int getHeight(int i, int largura) {
        return svg.getHeight(i, largura);
    }

    public String getNameFileShape() {
        return nomeArqSimbolos;
    }
    /**
     * @param args the command line arguments
     */
    /*
    public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    	public void run() {
    	Frame f = new Frame("f");
    
    	new HTDialogShapes(f,"c").setVisible(true);
	
    
    }
    });
    }*/    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnOK;
    private javax.swing.JButton btnAbrir;
    private javax.swing.JButton btnSeta;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    // End of variables declaration//GEN-END:variables
}

